Subject: [mpls] RFC4875 and Juniper implementation

From: rufino <[email-masked]>
Date: Mon, 26 Jul 2010 16:07:40 -0400

Hi All:

I am learning p2mp, using Juniper implementation so that I can have better
understanding of this RFC. But comparing to the juniper implementations, I
have some questions:

on RFC4875 page 10:

This section describes modifications made to the Path message format
as specified in [RFC3209] and [RFC3473]. The Path message is
enhanced to signal one or more S2L sub-LSPs.* This is done by
including the S2L sub-LSP descriptor list in the Path message* as
shown below.

<Path Message> ::= <Common Header> [ <INTEGRITY> ]
                               [ [<MESSAGE_ID_ACK> | <MESSAGE_ID_NACK>] ...]
                               [ <MESSAGE_ID> ]
                               <SESSION> <RSVP_HOP>
                               <TIME_VALUES>
                               [ <EXPLICIT_ROUTE> ]
                               <LABEL_REQUEST>
                               [ <PROTECTION> ]
                               [ <LABEL_SET> ... ]
                               [ <SESSION_ATTRIBUTE> ]
                               [ <NOTIFY_REQUEST> ]
                               [ <ADMIN_STATUS> ]
                               [ <POLICY_DATA> ... ]
                               <sender descriptor>
                               [<S2L sub-LSP descriptor list>]

The following is the format of the S2L sub-LSP descriptor list.

<S2L sub-LSP descriptor list> ::= <S2L sub-LSP descriptor>
                                                [ <S2L sub-LSP descriptor
list> ]

<S2L sub-LSP descriptor> ::= <S2L_SUB_LSP>
                                          [ <P2MP SECONDARY_EXPLICIT_ROUTE>
]

I set up three PE routers, PE1 (10.100.3.1), PE2 (10.100.3.2) and PE3
(10.100.3.7) and with few P routers

here are what i got from juniper boxes:

on a PE1 router:

Jul 26 15:56:52.175328 *RSVP send Path 10.100.3.1->10.100.3.2 Len=248
fe-0/0/0.10*
Jul 26 15:56:52.175490   MessageID Len 12 Msg_ID: 34 Epoch: 7781352 (Ack
Desired)
Jul 26 15:56:52.175555   *Session13 Len 16 10.100.3.1(port/tunnel ID 6155
Ext-ID 10.100.3.1) Proto 0*
Jul 26 15:56:52.175639   Hop      Len 12 10.100.0.1/0x08dd4490
Jul 26 15:56:52.175690   Time     Len  8 30000 ms
Jul 26 15:56:52.175755   SrcRoute Len 20  10.100.0.2 S 10.100.0.30 S
Jul 26 15:56:52.175807   LabelRequest Len  8 EtherType 0x800
Jul 26 15:56:52.175864   *Properties Len 24 Primary path p2mp->r2 p2mp-pvc
name*
Jul 26 15:56:52.175920   SessionAttribute Len 16 Prio (7,0) flag 0x4
"r1->r2"
Jul 26 15:56:52.175979   *Sender12 Len 20 P2MP Sender 10.100.3.1(port/lsp
ID  1, branch ID 10)    SubGrpOrg ID 0xa640301*
Jul 26 15:56:52.176033   *SubLsp   Len  8 Destination 10.100.3.2*
Jul 26 15:56:52.176116   Tspec    Len 36 rate 0bps size 0bps peak Infbps m
20 M 1500
Jul 26 15:56:52.176170   ADspec   Len 48 MTU 1500
Jul 26 15:56:52.176226   RecRoute Len 12  10.100.0.1

Jul 26 15:56:52.572218 *RSVP recv Resv 10.100.0.2->10.100.0.1 Len=156
fe-0/0/0.10*
Jul 26 15:56:52.572346   MessageID Len 12 Msg_ID: 53 Epoch: 7771538 (Ack
Desired)
Jul 26 15:56:52.572404   *Session13 Len 16 10.100.3.1(port/tunnel ID 6155
Ext-ID 10.100.3.1) Proto 0*
Jul 26 15:56:52.572462   Hop      Len 12 10.100.0.2/0x08dd4490
Jul 26 15:56:52.572526   Time     Len  8 30000 ms
Jul 26 15:56:52.572577   Style    Len  8 SE
Jul 26 15:56:52.572656   Flow     Len 36 rate 0bps size 0bps peak Infbps m
20 M 1500
Jul 26 15:56:52.572717   *Filter12 Len 20 P2MP Sender 10.100.3.1(port/lsp
ID  1, branch ID 10)    SubGrpOrg ID 0xa640301*
Jul 26 15:56:52.572768   Label    Len  8  300016
Jul 26 15:56:52.572830   RecRoute Len 20  10.100.0.2 10.100.0.30
Jul 26 15:56:52.572882   *SubLsp   Len  8 Destination 10.100.3.2*

Jul 26 15:56:54.621105 *RSVP send Path 10.100.3.1->10.100.3.7 Len=256
fe-0/0/0.10*
Jul 26 15:56:54.621279   MessageID Len 12 Msg_ID: 35 Epoch: 7781352 (Ack
Desired)
Jul 26 15:56:54.621345   *Session13 Len 16 10.100.3.1(port/tunnel ID 6156
Ext-ID 10.100.3.1) Proto 0*
Jul 26 15:56:54.621406   Hop      Len 12 10.100.0.1/0x08dd4490
Jul 26 15:56:54.621457   Time     Len  8 30000 ms
Jul 26 15:56:54.621526   SrcRoute Len 28  10.100.0.2 S 10.100.0.26 S
10.100.0.50 S
Jul 26 15:56:54.621579   LabelRequest Len  8 EtherType 0x800
Jul 26 15:56:54.621636   *Properties Len 24 Primary path p2mp->r7 p2mp-pvc
name*
Jul 26 15:56:54.621847   SessionAttribute Len 16 Prio (7,0) flag 0x4
"r1->r7"
Jul 26 15:56:54.621929   *Sender12 Len 20 P2MP Sender 10.100.3.1(port/lsp
ID  1, branch ID 10)    SubGrpOrg ID 0xa640301*
Jul 26 15:56:54.621986   *SubLsp   Len  8 Destination 10.100.3.7*
Jul 26 15:56:54.622071   Tspec    Len 36 rate 0bps size 0bps peak Infbps m
20 M 1500
Jul 26 15:56:54.622128   ADspec   Len 48 MTU 1500
Jul 26 15:56:54.622203   RecRoute Len 12  10.100.0.1

Jul 26 15:56:55.221811 *RSVP recv Resv 10.100.0.2->10.100.0.1 Len=164
fe-0/0/0.10*
Jul 26 15:56:55.221989   MessageID Len 12 Msg_ID: 55 Epoch: 7771538 (Ack
Desired)
Jul 26 15:56:55.222052   *Session13 Len 16 10.100.3.1(port/tunnel ID 6156
Ext-ID 10.100.3.1) Proto 0*
Jul 26 15:56:55.222129   Hop      Len 12 10.100.0.2/0x08dd4490
Jul 26 15:56:55.222182   Time     Len  8 30000 ms
Jul 26 15:56:55.222233   Style    Len  8 SE
Jul 26 15:56:55.222314   Flow     Len 36 rate 0bps size 0bps peak Infbps m
20 M 1500
Jul 26 15:56:55.222377   *Filter12 Len 20 P2MP Sender 10.100.3.1(port/lsp
ID  1, branch ID 10)    SubGrpOrg ID 0xa640301*
Jul 26 15:56:55.222430   Label    Len  8  300032
Jul 26 15:56:55.222498   RecRoute Len 28  10.100.0.2 10.100.0.26 10.100.0.50
Jul 26 15:56:55.222553   *SubLsp   Len  8 Destination 10.100.3.7*

where is the [<S2L sub-LSP descriptor list>]? this "*SubLsp   Len  8
Destination 10.100.3.2"?

*_Dave*
*